![Setta Logo](images/setta-github-light.png#gh-light-mode-only)
![Setta Logo](images/setta-github-dark.png#gh-dark-mode-only)


<div align="center">
  
[![PyPI version](https://img.shields.io/pypi/v/setta?color=bright-green)](https://pypi.org/project/setta)
[![License](https://img.shields.io/pypi/l/setta?color=bright-green)](https://github.com/settadev/setta/blob/main/LICENSE)
[![Discord](https://img.shields.io/badge/Discord-Join-7389D8?logo=discord&logoColor=white)](https://discord.gg/MmHJz75bZ5)

</div>

## News

**February 20**: v0.0.4
- Allow subprocess start method to be specified (fork, spawn, forkserver)
- When doing a param sweep of in-memory functions, import them in parallel.
- Various style improvements

**February 18**: v0.0.3
- Big improvements to charts and in-memory functions

**February 2**: v0.0.2
- First release!


## What does Setta do?

Setta is a developer tool that streamlines Python coding, configuration, UI creation, and onboarding.

It enables you to:
- Skip the boilerplate parsers and frontend. 
- Effortlessly expose your Python functions as a flexible UI. 
- Configure, interact, and share with ease.

Here's a short intro video:

https://github.com/user-attachments/assets/0599b754-1fbc-470b-ad6f-ac44b01da761

## Getting started

Run this command in your terminal:

```
pip install setta
```

Then go to your project folder and enter:

```
setta
```

The Setta UI will now be available in your web browser at http://127.0.0.1:8000/.


## Documentation

Documentation is in progress: https://docs.setta.dev/

## Examples

Our examples are easy to run: https://github.com/settadev/examples

The current examples are focused on AI, like LLM training and image generation. We'll soon be adding examples for other domains too.

## Features

See our [Features](FEATURES.md) document for an overview of what Setta can do.


## Contributors

- [Kevin Musgrave](https://github.com/KevinMusgrave): co-creator & full-stack developer.
- [Jeff Musgrave](https://github.com/JeffMusgrave): co-creator, UI/UX developer, frontend developer, and designer.
